<?php

/* ----------------------------------------------------------------------------------
   A. Veneziani - Semplice script utilizzante socket UDP 
                  Elabora una stringa rendendola maiuscola
				  
				  Si può eseguirlo con l'inteprete a linea di comando
				  php.exe sito in c:\xampp\php\php.exe
   ---------------------------------------------------------------------------------- */				  

    // crea una socket UDP
    $sk1 = socket_create(AF_INET, SOCK_DGRAM, SOL_UDP);
	
	// fa' il bind, ossia assegna i dati relativi alla connessione
    socket_bind($sk1, "localhost", 2000);
	
	do {
        // controlla se ci sono dati da elaborare
		socket_recvfrom($sk1, $buf, 100, MSG_WAITALL, $da_host, $da_porta);
		
		// segnala un dato ricevuto	
		echo "Ho ricevuto da " . $da_host . " dalla porta " . $da_porta . "\nil seguente testo:  " . $buf;

		if ($buf == "")
 		    // se il pacchetto non contiene nulla indica che uscira' dal ciclo di elaborazione
			echo "\n\nEsco dal ciclo di elaborazione";	
		else
		{	
		    // altrimenti porta il valore a maiuscolo 
			echo "\n\n *** Lo converto in maiuscolo e lo rimando. ***\n\n";	
			$buf = strtoupper($buf);
		}
		
		// reinvia il dato elaborato (stringa portata a maiuscolo) 
		// (si noti che per il rinvio si usano i dati - host e porta - letti nel pacchetto
		//  in arrivo, ricavati dalla funzione socket_recvfrom(  )  )
		socket_sendto($sk1, $buf, strlen($buf), MSG_WAITALL, $da_host, $da_porta);
	
	} while ($buf != "*");    // ciclo di elaborazione dei dati ricevuti
		
	socket_close($sk1);    // chiusura della socket 

?>
